-- name: [CS] Goomba Gang
-- description: It's a Mushroom-a-Palooza!           \\#ff7777\\This Pack requires Character Select\nto use as a Library!

local globalModName = "Goomba Gang"

if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local E_GOOMBAP_MODEL = smlua_model_util_get_id("goombap_geo") -- Located in "actors"
local E_GOOMBOB_MODEL = smlua_model_util_get_id("goombob_geo") -- Located in "actors"
local E_GOOMBUD_MODEL = smlua_model_util_get_id("goombud_geo") -- Located in "actors"
local E_GOOMBOSS_MODEL = smlua_model_util_get_id("goomboss_geo") -- Located in "actors"
local E_SSTU_MODEL = smlua_model_util_get_id("sstu_geo") -- Located in "actors"

local TEX_GOOMBAP_LIFE_ICON = get_texture_info("goombap_icon") -- Located in "textures"
local TEX_GOOMBOB_LIFE_ICON = get_texture_info("goombob_icon") -- Located in "textures"
local TEX_GOOMBUD_LIFE_ICON = get_texture_info("goombud_icon") -- Located in "textures"
local TEX_GOOMBOSS_LIFE_ICON = get_texture_info("goomboss_icon") -- Located in "textures"
local TEX_SSTU_LIFE_ICON = get_texture_info("sstu_icon") -- Located in "textures"

local VOICETABLE_GOOMBAP = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Punch2.ogg', 'Jump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TripleJump1.ogg', 'TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Whoa.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'GetStar.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'GrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Dying.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'GetStar.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Whoa.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Dying.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Snore.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Cough.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Whoa.ogg' -- Booted out of level
}

local VOICETABLE_GOOMBOSS = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Punch2.ogg', 'Jump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TripleJump1.ogg', 'TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Whoa.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'GetStar.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'GrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Dying.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'GetStar.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Whoa.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Dying.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Snore.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Cough.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Whoa.ogg' -- Booted out of level
}

local VOICETABLE_GOOMBOB = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Punch2.ogg', 'Jump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TripleJump1.ogg', 'TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Whoa.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'GetStar.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'GrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Dying.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'GetStar.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Whoa.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Dying.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Snore.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Cough.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Whoa.ogg' -- Booted out of level
}

local VOICETABLE_GOOMBUD = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Punch2.ogg', 'Jump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TripleJump1.ogg', 'TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Whoa.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'GetStar.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'GrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Dying.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'GetStar.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Whoa.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Dying.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Snore.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Cough.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Whoa.ogg' -- Booted out of level
}

local VOICETABLE_SSTU = {
    --[CHAR_SOUND_OKEY_DOKEY] = 'GetStar.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] = 'GetStar.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] = 'Punch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] = 'Punch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] = 'Punch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] = {'Jump1.ogg', 'Punch2.ogg', 'Jump1.ogg'}, -- First/Second jump sounds
	[CHAR_SOUND_HOOHOO] = 'DoubleJump.ogg', -- Third jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'TripleJump1.ogg', 'TripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] = 'Whoa.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] = 'Silent.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] = 'Silent.ogg', -- Same sound as UH2; jumping onto ledge
	[CHAR_SOUND_HAHA] = 'GetStar.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] = 'Jump1.ogg', -- Long jump
	[CHAR_SOUND_DOH] = 'Damaged.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] = 'GrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] = 'Silent.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] = 'Dying.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] = 'TripleJump2.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] = 'Silent.ogg', 
	[CHAR_SOUND_HRMM] = 'GrabItem.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] = 'GetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] = 'GetStar.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'Whoa.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'Silent.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'Dying.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'Snore.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'Silent.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'Cough.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'Silent.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'Silent.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'Cough.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'Silent.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'Silent.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'Dying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'Dying.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'Whoa.ogg' -- Booted out of level
}

local CAPTABLE_GOOMBAP = {
    normal = smlua_model_util_get_id("powerflower_geo"),
    wing = smlua_model_util_get_id("powerflower_geo"),
    metal = smlua_model_util_get_id("powerflower_geo"),
}

local CAPTABLE_GOOMBOSS = {
    normal = smlua_model_util_get_id("gbvanish_geo"),
    wing = smlua_model_util_get_id("gbwing_geo"),
    metal = smlua_model_util_get_id("gbmetal_geo"),
}

local CAPTABLE_GOOMBOB = {
    normal = smlua_model_util_get_id("powerflower_geo"),
    wing = smlua_model_util_get_id("powerflower_geo"),
    metal = smlua_model_util_get_id("powerflower_geo"),
}

local CAPTABLE_GOOMBUD = {
    normal = smlua_model_util_get_id("powerflower_geo"),
    wing = smlua_model_util_get_id("powerflower_geo"),
    metal = smlua_model_util_get_id("powerflower_geo"),
}

local CAPTABLE_SSTU = {
    normal = smlua_model_util_get_id("powerflower_geo"),
    wing = smlua_model_util_get_id("powerflower_geo"),
    metal = smlua_model_util_get_id("powerflower_geo"),
}

local PALETTE_GOOMBAP = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "CB0800",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FFA1D6",
    [CAP]    = "FFA1D6",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_GOOMBOB = {
    [PANTS]  = "ffffff",
    [SHIRT]  = "FF0007",
    [GLOVES] = "ffffff",
    [SHOES]  = "FFA800",
    [HAIR]   = "FFA800",
    [SKIN]   = "0098FF",
    [CAP]    = "FF0007",
	[EMBLEM] = "FFFFFF",
}

local PALETTE_GOOMBUD = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FF91FF",
    [GLOVES] = "91928D",
    [SHOES]  = "FF40BD",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "0006CB",
    [CAP]    = "FFFFFF",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_GOOMBOSS = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FF4B2F",
    [CAP]    = "183094",
    [EMBLEM]  = "FFFFFF",
}

local PALETTE_SSTU = {
    [PANTS]  = "FFFFFF",
    [SHIRT]  = "FFFFFF",
    [GLOVES] = "FFFFFF",
    [SHOES]  = "FFFFFF",
    [HAIR]   = "FFFFFF",
    [SKIN]   = "FF4B2F",
    [CAP]    = "183094",
    [EMBLEM]  = "FFFFFF",
}

local CSloaded = false
local function on_character_select_load()
	
	CT_GOOMBAP = _G.charSelect.character_add("Goomba", {"Malevolent Mushroom", "Model from: Mario Party 3"}, "Garrulous64", {r = 255, g = 100, b = 100}, E_GOOMBAP_MODEL, CT_GOOMBAP, TEX_GOOMBAP_LIFE_ICON)
    _G.charSelect.character_add_caps(E_GOOMBAP_MODEL, CAPTABLE_GOOMBAP)
    _G.charSelect.character_add_voice(E_GOOMBAP_MODEL, VOICETABLE_GOOMBAP)
    _G.charSelect.character_add_palette_preset(E_GOOMBAP_MODEL, PALETTE_GOOMBAP)
	
	CT_GOOMBOB = _G.charSelect.character_add("Galoomba", {"Also known as Goombob!", "Custom Model by: MrHeck"}, "Garrulous64", {r = 255, g = 100, b = 100}, E_GOOMBOB_MODEL, CT_GOOMBOB, TEX_GOOMBOB_LIFE_ICON)
    _G.charSelect.character_add_caps(E_GOOMBOB_MODEL, CAPTABLE_GOOMBOB)
    _G.charSelect.character_add_voice(E_GOOMBOB_MODEL, VOICETABLE_GOOMBOB)
    _G.charSelect.character_add_palette_preset(E_GOOMBOB_MODEL, PALETTE_GOOMBOB)

    CT_GOOMBUD = _G.charSelect.character_add("Goombud", {"Super Mario Maker's Finest", "Custom Model by MrHeck"}, "Garrulous64", {r = 255, g = 100, b = 100}, E_GOOMBUD_MODEL, CT_GOOMBUD, TEX_GOOMBUD_LIFE_ICON)
    _G.charSelect.character_add_voice(E_GOOMBUD_MODEL, VOICETABLE_GOOMBUD)
    _G.charSelect.character_add_palette_preset(E_GOOMBUD_MODEL, PALETTE_GOOMBUD)
	_G.charSelect.character_add_caps(E_GOOMBUD_MODEL, CAPTABLE_GOOMBUD)

    CT_GOOMBOSS = _G.charSelect.character_add("Goomboss", {"Also known as Goomba King!", "Custom Model by: MrHeck"}, "Garrulous64", {r = 255, g = 100, b = 100}, E_GOOMBOSS_MODEL, CT_GOOMBOSS, TEX_GOOMBOSS_LIFE_ICON)
    _G.charSelect.character_add_voice(E_GOOMBOSS_MODEL, VOICETABLE_GOOMBOSS)
    _G.charSelect.character_add_palette_preset(E_GOOMBOSS_MODEL, PALETTE_GOOMBOSS)
	_G.charSelect.character_add_caps(E_GOOMBOSS_MODEL, CAPTABLE_GOOMBOSS)
	
	CT_SSTU = _G.charSelect.character_add("Strollin' Stu", {"Nobody's gonna break their stride", "Custom Model by: G.U.N."}, "Garrulous64", {r = 255, g = 127, b = 80}, E_SSTU_MODEL, CT_SSTU, TEX_SSTU_LIFE_ICON)
    _G.charSelect.character_add_voice(E_SSTU_MODEL, VOICETABLE_SSTU)
    _G.charSelect.character_add_palette_preset(E_SSTU_MODEL, PALETTE_SSTU)
	_G.charSelect.character_add_caps(E_SSTU_MODEL, CAPTABLE_SSTU)

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBAP then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBOB then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBUD then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBOSS then return _G.charSelect.voice.sound(m, sound) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_SSTU then return _G.charSelect.voice.sound(m, sound) end
end

local function on_character_snore(m)
    if not CSloaded then return end
    if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBAP then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBOB then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBUD then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_GOOMBOSS then return _G.charSelect.voice.snore(m) end
	if _G.charSelect.character_get_voice(m) == VOICETABLE_SSTU then return _G.charSelect.voice.snore(m) end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)